default:
  tags: [docker]
  image: registry.fedoraproject.org/fedora:35

stages:
  - lint
  - unit-tests
  - deploy

before_script:
  - dnf -y install python3-pip make git which
  - curl -sSL https://raw.githubusercontent.com/python-poetry/poetry/master/get-poetry.py | python3 -
  - source $HOME/.poetry/env
  - poetry install

lint:
  stage: lint
  script:
    - make lint

unit:
  stage: unit-tests
  script:
    - make tests
  coverage: '/^  COVERAGE: ([0-9.]+)%$/'
  artifacts:
    reports:
      coverage_report:
        coverage_format: cobertura
        path: coverage.xml
      junit: report.xml

deploy_stage:
  stage: deploy
  script:
    - pip3 install ansible openshift
    - ansible-galaxy collection install kubernetes.core
    - |
      make deploy \
        "OCP_HOST=${OCP_HOST}" \
        "OCP_NS=${OCP_NS}" \
        "OCP_KEY=${OCP_KEY}" \
        "TARGET_REPO_URL=${TARGET_REPO_URL}" \
        "TARGET_REPO_BRANCH=${TARGET_REPO_BRANCH}" \
        "NO_CONTAINER=1"
  environment:
    name: upstream/stage
  when: manual

deploy_prod:
  stage: deploy
  script:
    - pip3 install ansible openshift
    - ansible-galaxy collection install kubernetes.core
    - |
      make deploy \
        "OCP_HOST=${OCP_HOST}" \
        "OCP_NS=${OCP_NS}" \
        "OCP_KEY=${OCP_KEY}" \
        "TARGET_REPO_URL=${TARGET_REPO_URL}" \
        "TARGET_REPO_BRANCH=${TARGET_REPO_BRANCH}" \
        "NO_CONTAINER=1"
  environment:
    name: upstream/prod
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
      when: manual
